package io.dekorate.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class DekorateConifgBuilder extends DekorateConifgFluentImpl<DekorateConifgBuilder> implements VisitableBuilder<DekorateConifg,DekorateConifgBuilder>{

    DekorateConifgFluent<?> fluent;
    Boolean validationEnabled;

    public DekorateConifgBuilder(){
            this(true);
    }
    public DekorateConifgBuilder(Boolean validationEnabled){
            this(new DekorateConifg(), validationEnabled);
    }
    public DekorateConifgBuilder(DekorateConifgFluent<?> fluent){
            this(fluent, true);
    }
    public DekorateConifgBuilder(DekorateConifgFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new DekorateConifg(), validationEnabled);
    }
    public DekorateConifgBuilder(DekorateConifgFluent<?> fluent,DekorateConifg instance){
            this(fluent, instance, true);
    }
    public DekorateConifgBuilder(DekorateConifgFluent<?> fluent,DekorateConifg instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withResources(instance.getResources()); 
            this.validationEnabled = validationEnabled; 
    }
    public DekorateConifgBuilder(DekorateConifg instance){
            this(instance,true);
    }
    public DekorateConifgBuilder(DekorateConifg instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withResources(instance.getResources()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableDekorateConifg build(){
            EditableDekorateConifg buildable = new EditableDekorateConifg(fluent.getResources());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            DekorateConifgBuilder that = (DekorateConifgBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
