package io.dekorate.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.util.ArrayList;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.String;
import java.lang.Boolean;

public class DekorateConifgFluentImpl<A extends DekorateConifgFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements DekorateConifgFluent<A>{

    private List<String> resources = new ArrayList<String>();

    public DekorateConifgFluentImpl(){
    }
    public DekorateConifgFluentImpl(DekorateConifg instance){
            this.withResources(instance.getResources()); 
    }

    public A withResources(String... resources){
            if (this.resources != null) {this.resources.clear();}
            if (resources != null) {for (String item :resources){ this.addToResources(item);}} return (A) this;
    }

    public String[] getResources(){
            //This needs to work with primitives, so we use arrays.
int size = resources != null ? resources.size() : 0;
String[] result = new String[size];
if (size == 0) {
   return result;
}
int index = 0;
for (String item : resources) {
    result[index++]=item;
}
return result;

    }

    public A addToResources(int index,String item){
            if (this.resources == null) {this.resources = new ArrayList<String>();}
            this.resources.add(index, item);
            return (A)this;
    }

    public A setToResources(int index,String item){
            if (this.resources == null) {this.resources = new ArrayList<String>();}
            this.resources.set(index, item); return (A)this;
    }

    public A addToResources(String... items){
            if (this.resources == null) {this.resources = new ArrayList<String>();}
            for (String item : items) {this.resources.add(item);} return (A)this;
    }

    public A addAllToResources(Collection<String> items){
            if (this.resources == null) {this.resources = new ArrayList<String>();}
            for (String item : items) {this.resources.add(item);} return (A)this;
    }

    public A removeFromResources(String... items){
            for (String item : items) {if (this.resources!= null){ this.resources.remove(item);}} return (A)this;
    }

    public A removeAllFromResources(Collection<String> items){
            for (String item : items) {if (this.resources!= null){ this.resources.remove(item);}} return (A)this;
    }

    public Boolean hasResources(){
            return resources != null && !resources.isEmpty();
    }

    public A addNewResource(String arg1){
            return (A)addToResources(new String(arg1));
    }

    public A addNewResource(StringBuilder arg1){
            return (A)addToResources(new String(arg1));
    }

    public A addNewResource(StringBuffer arg1){
            return (A)addToResources(new String(arg1));
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            DekorateConifgFluentImpl that = (DekorateConifgFluentImpl) o;
            if (resources != null ? !resources.equals(that.resources) :that.resources != null) return false;
            return true;
    }




}
