package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class AwsElasticBlockStoreVolumeFluentImpl<A extends AwsElasticBlockStoreVolumeFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements AwsElasticBlockStoreVolumeFluent<A>{

    private String volumeName;
    private String volumeId;
    private int partition;
    private String fsType = "ext4";
    private boolean readOnly = false;

    public AwsElasticBlockStoreVolumeFluentImpl(){
    }
    public AwsElasticBlockStoreVolumeFluentImpl(io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume instance){
            this.withVolumeName(instance.getVolumeName()); 
            this.withVolumeId(instance.getVolumeId()); 
            this.withPartition(instance.getPartition()); 
            this.withFsType(instance.getFsType()); 
            this.withReadOnly(instance.isReadOnly()); 
    }

    public String getVolumeName(){
            return this.volumeName;
    }

    public A withVolumeName(String volumeName){
            this.volumeName=volumeName; return (A) this;
    }

    public Boolean hasVolumeName(){
            return this.volumeName != null;
    }

    public A withNewVolumeName(String arg1){
            return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuilder arg1){
            return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuffer arg1){
            return (A)withVolumeName(new String(arg1));
    }

    public String getVolumeId(){
            return this.volumeId;
    }

    public A withVolumeId(String volumeId){
            this.volumeId=volumeId; return (A) this;
    }

    public Boolean hasVolumeId(){
            return this.volumeId != null;
    }

    public A withNewVolumeId(String arg1){
            return (A)withVolumeId(new String(arg1));
    }

    public A withNewVolumeId(StringBuilder arg1){
            return (A)withVolumeId(new String(arg1));
    }

    public A withNewVolumeId(StringBuffer arg1){
            return (A)withVolumeId(new String(arg1));
    }

    public int getPartition(){
            return this.partition;
    }

    public A withPartition(int partition){
            this.partition=partition; return (A) this;
    }

    public Boolean hasPartition(){
            return true;
    }

    public String getFsType(){
            return this.fsType;
    }

    public A withFsType(String fsType){
            this.fsType=fsType; return (A) this;
    }

    public Boolean hasFsType(){
            return this.fsType != null;
    }

    public A withNewFsType(String arg1){
            return (A)withFsType(new String(arg1));
    }

    public A withNewFsType(StringBuilder arg1){
            return (A)withFsType(new String(arg1));
    }

    public A withNewFsType(StringBuffer arg1){
            return (A)withFsType(new String(arg1));
    }

    public boolean isReadOnly(){
            return this.readOnly;
    }

    public A withReadOnly(boolean readOnly){
            this.readOnly=readOnly; return (A) this;
    }

    public Boolean hasReadOnly(){
            return true;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            AwsElasticBlockStoreVolumeFluentImpl that = (AwsElasticBlockStoreVolumeFluentImpl) o;
            if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
            if (volumeId != null ? !volumeId.equals(that.volumeId) :that.volumeId != null) return false;
            if (partition != that.partition) return false;
            if (fsType != null ? !fsType.equals(that.fsType) :that.fsType != null) return false;
            if (readOnly != that.readOnly) return false;
            return true;
    }




}
