package io.dekorate.kubernetes.config;

import java.lang.String;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class AzureDiskVolume{

    private String volumeName;
    private String diskName;
    private String diskURI;
    private String kind = "Managed";
    private String cachingMode = "ReadWrite";
    private String fsType = "ext4";
    private boolean readOnly = false;

    public AzureDiskVolume(){
    }
    public AzureDiskVolume(String volumeName,String diskName,String diskURI,String kind,String cachingMode,String fsType,boolean readOnly){
            this.volumeName = volumeName;
            this.diskName = diskName;
            this.diskURI = diskURI;
            this.kind = kind != null ? kind : "Managed";
            this.cachingMode = cachingMode != null ? cachingMode : "ReadWrite";
            this.fsType = fsType != null ? fsType : "ext4";
            this.readOnly = readOnly;
    }

    public String getVolumeName(){
            return this.volumeName;
    }

    public String getDiskName(){
            return this.diskName;
    }

    public String getDiskURI(){
            return this.diskURI;
    }

    public String getKind(){
            return this.kind;
    }

    public String getCachingMode(){
            return this.cachingMode;
    }

    public String getFsType(){
            return this.fsType;
    }

    public boolean isReadOnly(){
            return this.readOnly;
    }




}
