package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class AzureDiskVolumeBuilder extends AzureDiskVolumeFluentImpl<AzureDiskVolumeBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.AzureDiskVolume,AzureDiskVolumeBuilder>{

    AzureDiskVolumeFluent<?> fluent;
    Boolean validationEnabled;

    public AzureDiskVolumeBuilder(){
            this(true);
    }
    public AzureDiskVolumeBuilder(Boolean validationEnabled){
            this(new AzureDiskVolume(), validationEnabled);
    }
    public AzureDiskVolumeBuilder(AzureDiskVolumeFluent<?> fluent){
            this(fluent, true);
    }
    public AzureDiskVolumeBuilder(AzureDiskVolumeFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new AzureDiskVolume(), validationEnabled);
    }
    public AzureDiskVolumeBuilder(AzureDiskVolumeFluent<?> fluent,io.dekorate.kubernetes.config.AzureDiskVolume instance){
            this(fluent, instance, true);
    }
    public AzureDiskVolumeBuilder(AzureDiskVolumeFluent<?> fluent,io.dekorate.kubernetes.config.AzureDiskVolume instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withVolumeName(instance.getVolumeName()); 
            fluent.withDiskName(instance.getDiskName()); 
            fluent.withDiskURI(instance.getDiskURI()); 
            fluent.withKind(instance.getKind()); 
            fluent.withCachingMode(instance.getCachingMode()); 
            fluent.withFsType(instance.getFsType()); 
            fluent.withReadOnly(instance.isReadOnly()); 
            this.validationEnabled = validationEnabled; 
    }
    public AzureDiskVolumeBuilder(io.dekorate.kubernetes.config.AzureDiskVolume instance){
            this(instance,true);
    }
    public AzureDiskVolumeBuilder(io.dekorate.kubernetes.config.AzureDiskVolume instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withVolumeName(instance.getVolumeName()); 
            this.withDiskName(instance.getDiskName()); 
            this.withDiskURI(instance.getDiskURI()); 
            this.withKind(instance.getKind()); 
            this.withCachingMode(instance.getCachingMode()); 
            this.withFsType(instance.getFsType()); 
            this.withReadOnly(instance.isReadOnly()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableAzureDiskVolume build(){
            EditableAzureDiskVolume buildable = new EditableAzureDiskVolume(fluent.getVolumeName(),fluent.getDiskName(),fluent.getDiskURI(),fluent.getKind(),fluent.getCachingMode(),fluent.getFsType(),fluent.isReadOnly());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            AzureDiskVolumeBuilder that = (AzureDiskVolumeBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
