package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class AzureFileVolumeFluentImpl<A extends AzureFileVolumeFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements AzureFileVolumeFluent<A>{

    private String volumeName;
    private String shareName;
    private String secretName;
    private boolean readOnly = false;

    public AzureFileVolumeFluentImpl(){
    }
    public AzureFileVolumeFluentImpl(io.dekorate.kubernetes.config.AzureFileVolume instance){
            this.withVolumeName(instance.getVolumeName()); 
            this.withShareName(instance.getShareName()); 
            this.withSecretName(instance.getSecretName()); 
            this.withReadOnly(instance.isReadOnly()); 
    }

    public String getVolumeName(){
            return this.volumeName;
    }

    public A withVolumeName(String volumeName){
            this.volumeName=volumeName; return (A) this;
    }

    public Boolean hasVolumeName(){
            return this.volumeName != null;
    }

    public A withNewVolumeName(String arg1){
            return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuilder arg1){
            return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuffer arg1){
            return (A)withVolumeName(new String(arg1));
    }

    public String getShareName(){
            return this.shareName;
    }

    public A withShareName(String shareName){
            this.shareName=shareName; return (A) this;
    }

    public Boolean hasShareName(){
            return this.shareName != null;
    }

    public A withNewShareName(String arg1){
            return (A)withShareName(new String(arg1));
    }

    public A withNewShareName(StringBuilder arg1){
            return (A)withShareName(new String(arg1));
    }

    public A withNewShareName(StringBuffer arg1){
            return (A)withShareName(new String(arg1));
    }

    public String getSecretName(){
            return this.secretName;
    }

    public A withSecretName(String secretName){
            this.secretName=secretName; return (A) this;
    }

    public Boolean hasSecretName(){
            return this.secretName != null;
    }

    public A withNewSecretName(String arg1){
            return (A)withSecretName(new String(arg1));
    }

    public A withNewSecretName(StringBuilder arg1){
            return (A)withSecretName(new String(arg1));
    }

    public A withNewSecretName(StringBuffer arg1){
            return (A)withSecretName(new String(arg1));
    }

    public boolean isReadOnly(){
            return this.readOnly;
    }

    public A withReadOnly(boolean readOnly){
            this.readOnly=readOnly; return (A) this;
    }

    public Boolean hasReadOnly(){
            return true;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            AzureFileVolumeFluentImpl that = (AzureFileVolumeFluentImpl) o;
            if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
            if (shareName != null ? !shareName.equals(that.shareName) :that.shareName != null) return false;
            if (secretName != null ? !secretName.equals(that.secretName) :that.secretName != null) return false;
            if (readOnly != that.readOnly) return false;
            return true;
    }




}
