package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class ConfigMapVolumeFluentImpl<A extends ConfigMapVolumeFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements ConfigMapVolumeFluent<A>{

    private String volumeName;
    private String configMapName;
    private int defaultMode = 384;
    private boolean optional = false;

    public ConfigMapVolumeFluentImpl(){
    }
    public ConfigMapVolumeFluentImpl(io.dekorate.kubernetes.config.ConfigMapVolume instance){
            this.withVolumeName(instance.getVolumeName()); 
            this.withConfigMapName(instance.getConfigMapName()); 
            this.withDefaultMode(instance.getDefaultMode()); 
            this.withOptional(instance.isOptional()); 
    }

    public String getVolumeName(){
            return this.volumeName;
    }

    public A withVolumeName(String volumeName){
            this.volumeName=volumeName; return (A) this;
    }

    public Boolean hasVolumeName(){
            return this.volumeName != null;
    }

    public A withNewVolumeName(String arg1){
            return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuilder arg1){
            return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuffer arg1){
            return (A)withVolumeName(new String(arg1));
    }

    public String getConfigMapName(){
            return this.configMapName;
    }

    public A withConfigMapName(String configMapName){
            this.configMapName=configMapName; return (A) this;
    }

    public Boolean hasConfigMapName(){
            return this.configMapName != null;
    }

    public A withNewConfigMapName(String arg1){
            return (A)withConfigMapName(new String(arg1));
    }

    public A withNewConfigMapName(StringBuilder arg1){
            return (A)withConfigMapName(new String(arg1));
    }

    public A withNewConfigMapName(StringBuffer arg1){
            return (A)withConfigMapName(new String(arg1));
    }

    public int getDefaultMode(){
            return this.defaultMode;
    }

    public A withDefaultMode(int defaultMode){
            this.defaultMode=defaultMode; return (A) this;
    }

    public Boolean hasDefaultMode(){
            return true;
    }

    public boolean isOptional(){
            return this.optional;
    }

    public A withOptional(boolean optional){
            this.optional=optional; return (A) this;
    }

    public Boolean hasOptional(){
            return true;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            ConfigMapVolumeFluentImpl that = (ConfigMapVolumeFluentImpl) o;
            if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
            if (configMapName != null ? !configMapName.equals(that.configMapName) :that.configMapName != null) return false;
            if (defaultMode != that.defaultMode) return false;
            if (optional != that.optional) return false;
            return true;
    }




}
