package io.dekorate.kubernetes.config;

import io.dekorate.project.ProjectFluentImpl;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.LinkedHashMap;
import io.dekorate.project.Project;
import io.dekorate.project.ProjectBuilder;
import java.lang.Deprecated;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.Boolean;
import java.util.Map;

public class ConfigurationFluentImpl<A extends ConfigurationFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements ConfigurationFluent<A>{

    private ProjectBuilder project;
    private Map<ConfigKey,Object> attributes;

    public ConfigurationFluentImpl(){
    }
    public ConfigurationFluentImpl(Configuration instance){
            this.withProject(instance.getProject()); 
            this.withAttributes(instance.getAttributes()); 
    }

    
/**
 * This method has been deprecated, please use method buildProject instead.
 * @return The buildable object.
 */
@Deprecated public Project getProject(){
            return this.project!=null?this.project.build():null;
    }

    public Project buildProject(){
            return this.project!=null?this.project.build():null;
    }

    public A withProject(Project project){
            _visitables.get("project").remove(this.project);
            if (project!=null){ this.project= new ProjectBuilder(project); _visitables.get("project").add(this.project);} return (A) this;
    }

    public Boolean hasProject(){
            return this.project != null;
    }

    public ConfigurationFluent.ProjectNested<A> withNewProject(){
            return new ProjectNestedImpl();
    }

    public ConfigurationFluent.ProjectNested<A> withNewProjectLike(Project item){
            return new ProjectNestedImpl(item);
    }

    public ConfigurationFluent.ProjectNested<A> editProject(){
            return withNewProjectLike(getProject());
    }

    public ConfigurationFluent.ProjectNested<A> editOrNewProject(){
            return withNewProjectLike(getProject() != null ? getProject(): new ProjectBuilder().build());
    }

    public ConfigurationFluent.ProjectNested<A> editOrNewProjectLike(Project item){
            return withNewProjectLike(getProject() != null ? getProject(): item);
    }

    public A addToAttributes(ConfigKey key,Object value){
            if(this.attributes == null && key != null && value != null) { this.attributes = new LinkedHashMap<ConfigKey,Object>(); }
            if(key != null && value != null) {this.attributes.put(key, value);} return (A)this;
    }

    public A addToAttributes(Map<ConfigKey,Object> map){
            if(this.attributes == null && map != null) { this.attributes = new LinkedHashMap<ConfigKey,Object>(); }
            if(map != null) { this.attributes.putAll(map);} return (A)this;
    }

    public A removeFromAttributes(ConfigKey key){
            if(this.attributes == null) { return (A) this; }
            if(key != null && this.attributes != null) {this.attributes.remove(key);} return (A)this;
    }

    public A removeFromAttributes(Map<ConfigKey,Object> map){
            if(this.attributes == null) { return (A) this; }
            if(map != null) { for(Object key : map.keySet()) {if (this.attributes != null){this.attributes.remove(key);}}} return (A)this;
    }

    public Map<ConfigKey,Object> getAttributes(){
            return this.attributes;
    }

    public A withAttributes(Map<ConfigKey,Object> attributes){
            if (attributes == null) { this.attributes =  null;} else {this.attributes = new LinkedHashMap<ConfigKey,Object>(attributes);} return (A) this;
    }

    public Boolean hasAttributes(){
            return this.attributes != null;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            ConfigurationFluentImpl that = (ConfigurationFluentImpl) o;
            if (project != null ? !project.equals(that.project) :that.project != null) return false;
            if (attributes != null ? !attributes.equals(that.attributes) :that.attributes != null) return false;
            return true;
    }


    public class ProjectNestedImpl<N> extends ProjectFluentImpl<ConfigurationFluent.ProjectNested<N>> implements ConfigurationFluent.ProjectNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final ProjectBuilder builder;
    
            ProjectNestedImpl(Project item){
                    this.builder = new ProjectBuilder(this, item);
            }
            ProjectNestedImpl(){
                    this.builder = new ProjectBuilder(this);
            }
    
    public N and(){
            return (N) ConfigurationFluentImpl.this.withProject(builder.build());
    }
    public N endProject(){
            return and();
    }

}


}
