package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class EnvBuilder extends EnvFluentImpl<EnvBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.Env,EnvBuilder>{

    EnvFluent<?> fluent;
    Boolean validationEnabled;

    public EnvBuilder(){
            this(true);
    }
    public EnvBuilder(Boolean validationEnabled){
            this(new Env(), validationEnabled);
    }
    public EnvBuilder(EnvFluent<?> fluent){
            this(fluent, true);
    }
    public EnvBuilder(EnvFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Env(), validationEnabled);
    }
    public EnvBuilder(EnvFluent<?> fluent,io.dekorate.kubernetes.config.Env instance){
            this(fluent, instance, true);
    }
    public EnvBuilder(EnvFluent<?> fluent,io.dekorate.kubernetes.config.Env instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withName(instance.getName()); 
            fluent.withValue(instance.getValue()); 
            fluent.withSecret(instance.getSecret()); 
            fluent.withConfigmap(instance.getConfigmap()); 
            fluent.withField(instance.getField()); 
            this.validationEnabled = validationEnabled; 
    }
    public EnvBuilder(io.dekorate.kubernetes.config.Env instance){
            this(instance,true);
    }
    public EnvBuilder(io.dekorate.kubernetes.config.Env instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withName(instance.getName()); 
            this.withValue(instance.getValue()); 
            this.withSecret(instance.getSecret()); 
            this.withConfigmap(instance.getConfigmap()); 
            this.withField(instance.getField()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableEnv build(){
            EditableEnv buildable = new EditableEnv(fluent.getName(),fluent.getValue(),fluent.getSecret(),fluent.getConfigmap(),fluent.getField());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            EnvBuilder that = (EnvBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
