package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class EnvFluentImpl<A extends EnvFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements EnvFluent<A>{

    private String name;
    private String value = "";
    private String secret = "";
    private String configmap = "";
    private String field = "";

    public EnvFluentImpl(){
    }
    public EnvFluentImpl(io.dekorate.kubernetes.config.Env instance){
            this.withName(instance.getName()); 
            this.withValue(instance.getValue()); 
            this.withSecret(instance.getSecret()); 
            this.withConfigmap(instance.getConfigmap()); 
            this.withField(instance.getField()); 
    }

    public String getName(){
            return this.name;
    }

    public A withName(String name){
            this.name=name; return (A) this;
    }

    public Boolean hasName(){
            return this.name != null;
    }

    public A withNewName(String arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuilder arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuffer arg1){
            return (A)withName(new String(arg1));
    }

    public String getValue(){
            return this.value;
    }

    public A withValue(String value){
            this.value=value; return (A) this;
    }

    public Boolean hasValue(){
            return this.value != null;
    }

    public A withNewValue(String arg1){
            return (A)withValue(new String(arg1));
    }

    public A withNewValue(StringBuilder arg1){
            return (A)withValue(new String(arg1));
    }

    public A withNewValue(StringBuffer arg1){
            return (A)withValue(new String(arg1));
    }

    public String getSecret(){
            return this.secret;
    }

    public A withSecret(String secret){
            this.secret=secret; return (A) this;
    }

    public Boolean hasSecret(){
            return this.secret != null;
    }

    public A withNewSecret(String arg1){
            return (A)withSecret(new String(arg1));
    }

    public A withNewSecret(StringBuilder arg1){
            return (A)withSecret(new String(arg1));
    }

    public A withNewSecret(StringBuffer arg1){
            return (A)withSecret(new String(arg1));
    }

    public String getConfigmap(){
            return this.configmap;
    }

    public A withConfigmap(String configmap){
            this.configmap=configmap; return (A) this;
    }

    public Boolean hasConfigmap(){
            return this.configmap != null;
    }

    public A withNewConfigmap(String arg1){
            return (A)withConfigmap(new String(arg1));
    }

    public A withNewConfigmap(StringBuilder arg1){
            return (A)withConfigmap(new String(arg1));
    }

    public A withNewConfigmap(StringBuffer arg1){
            return (A)withConfigmap(new String(arg1));
    }

    public String getField(){
            return this.field;
    }

    public A withField(String field){
            this.field=field; return (A) this;
    }

    public Boolean hasField(){
            return this.field != null;
    }

    public A withNewField(String arg1){
            return (A)withField(new String(arg1));
    }

    public A withNewField(StringBuilder arg1){
            return (A)withField(new String(arg1));
    }

    public A withNewField(StringBuffer arg1){
            return (A)withField(new String(arg1));
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            EnvFluentImpl that = (EnvFluentImpl) o;
            if (name != null ? !name.equals(that.name) :that.name != null) return false;
            if (value != null ? !value.equals(that.value) :that.value != null) return false;
            if (secret != null ? !secret.equals(that.secret) :that.secret != null) return false;
            if (configmap != null ? !configmap.equals(that.configmap) :that.configmap != null) return false;
            if (field != null ? !field.equals(that.field) :that.field != null) return false;
            return true;
    }




}
