package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class GitRepoVolumeFluentImpl<A extends GitRepoVolumeFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements GitRepoVolumeFluent<A>{

    private String volumeName;
    private String repository;
    private String directory = "";
    private String revision = "";

    public GitRepoVolumeFluentImpl(){
    }
    public GitRepoVolumeFluentImpl(io.dekorate.kubernetes.config.GitRepoVolume instance){
            this.withVolumeName(instance.getVolumeName()); 
            this.withRepository(instance.getRepository()); 
            this.withDirectory(instance.getDirectory()); 
            this.withRevision(instance.getRevision()); 
    }

    public String getVolumeName(){
            return this.volumeName;
    }

    public A withVolumeName(String volumeName){
            this.volumeName=volumeName; return (A) this;
    }

    public Boolean hasVolumeName(){
            return this.volumeName != null;
    }

    public A withNewVolumeName(String arg1){
            return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuilder arg1){
            return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuffer arg1){
            return (A)withVolumeName(new String(arg1));
    }

    public String getRepository(){
            return this.repository;
    }

    public A withRepository(String repository){
            this.repository=repository; return (A) this;
    }

    public Boolean hasRepository(){
            return this.repository != null;
    }

    public A withNewRepository(String arg1){
            return (A)withRepository(new String(arg1));
    }

    public A withNewRepository(StringBuilder arg1){
            return (A)withRepository(new String(arg1));
    }

    public A withNewRepository(StringBuffer arg1){
            return (A)withRepository(new String(arg1));
    }

    public String getDirectory(){
            return this.directory;
    }

    public A withDirectory(String directory){
            this.directory=directory; return (A) this;
    }

    public Boolean hasDirectory(){
            return this.directory != null;
    }

    public A withNewDirectory(String arg1){
            return (A)withDirectory(new String(arg1));
    }

    public A withNewDirectory(StringBuilder arg1){
            return (A)withDirectory(new String(arg1));
    }

    public A withNewDirectory(StringBuffer arg1){
            return (A)withDirectory(new String(arg1));
    }

    public String getRevision(){
            return this.revision;
    }

    public A withRevision(String revision){
            this.revision=revision; return (A) this;
    }

    public Boolean hasRevision(){
            return this.revision != null;
    }

    public A withNewRevision(String arg1){
            return (A)withRevision(new String(arg1));
    }

    public A withNewRevision(StringBuilder arg1){
            return (A)withRevision(new String(arg1));
    }

    public A withNewRevision(StringBuffer arg1){
            return (A)withRevision(new String(arg1));
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            GitRepoVolumeFluentImpl that = (GitRepoVolumeFluentImpl) o;
            if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
            if (repository != null ? !repository.equals(that.repository) :that.repository != null) return false;
            if (directory != null ? !directory.equals(that.directory) :that.directory != null) return false;
            if (revision != null ? !revision.equals(that.revision) :that.revision != null) return false;
            return true;
    }




}
