package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class MountBuilder extends MountFluentImpl<MountBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.Mount,MountBuilder>{

    MountFluent<?> fluent;
    Boolean validationEnabled;

    public MountBuilder(){
            this(true);
    }
    public MountBuilder(Boolean validationEnabled){
            this(new Mount(), validationEnabled);
    }
    public MountBuilder(MountFluent<?> fluent){
            this(fluent, true);
    }
    public MountBuilder(MountFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Mount(), validationEnabled);
    }
    public MountBuilder(MountFluent<?> fluent,io.dekorate.kubernetes.config.Mount instance){
            this(fluent, instance, true);
    }
    public MountBuilder(MountFluent<?> fluent,io.dekorate.kubernetes.config.Mount instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withName(instance.getName()); 
            fluent.withPath(instance.getPath()); 
            fluent.withSubPath(instance.getSubPath()); 
            fluent.withReadOnly(instance.isReadOnly()); 
            this.validationEnabled = validationEnabled; 
    }
    public MountBuilder(io.dekorate.kubernetes.config.Mount instance){
            this(instance,true);
    }
    public MountBuilder(io.dekorate.kubernetes.config.Mount instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withName(instance.getName()); 
            this.withPath(instance.getPath()); 
            this.withSubPath(instance.getSubPath()); 
            this.withReadOnly(instance.isReadOnly()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableMount build(){
            EditableMount buildable = new EditableMount(fluent.getName(),fluent.getPath(),fluent.getSubPath(),fluent.isReadOnly());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            MountBuilder that = (MountBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
