package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class PersistentVolumeClaimVolumeBuilder extends PersistentVolumeClaimVolumeFluentImpl<PersistentVolumeClaimVolumeBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.PersistentVolumeClaimVolume,PersistentVolumeClaimVolumeBuilder>{

    PersistentVolumeClaimVolumeFluent<?> fluent;
    Boolean validationEnabled;

    public PersistentVolumeClaimVolumeBuilder(){
            this(true);
    }
    public PersistentVolumeClaimVolumeBuilder(Boolean validationEnabled){
            this(new PersistentVolumeClaimVolume(), validationEnabled);
    }
    public PersistentVolumeClaimVolumeBuilder(PersistentVolumeClaimVolumeFluent<?> fluent){
            this(fluent, true);
    }
    public PersistentVolumeClaimVolumeBuilder(PersistentVolumeClaimVolumeFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new PersistentVolumeClaimVolume(), validationEnabled);
    }
    public PersistentVolumeClaimVolumeBuilder(PersistentVolumeClaimVolumeFluent<?> fluent,io.dekorate.kubernetes.config.PersistentVolumeClaimVolume instance){
            this(fluent, instance, true);
    }
    public PersistentVolumeClaimVolumeBuilder(PersistentVolumeClaimVolumeFluent<?> fluent,io.dekorate.kubernetes.config.PersistentVolumeClaimVolume instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withVolumeName(instance.getVolumeName()); 
            fluent.withClaimName(instance.getClaimName()); 
            fluent.withReadOnly(instance.isReadOnly()); 
            this.validationEnabled = validationEnabled; 
    }
    public PersistentVolumeClaimVolumeBuilder(io.dekorate.kubernetes.config.PersistentVolumeClaimVolume instance){
            this(instance,true);
    }
    public PersistentVolumeClaimVolumeBuilder(io.dekorate.kubernetes.config.PersistentVolumeClaimVolume instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withVolumeName(instance.getVolumeName()); 
            this.withClaimName(instance.getClaimName()); 
            this.withReadOnly(instance.isReadOnly()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditablePersistentVolumeClaimVolume build(){
            EditablePersistentVolumeClaimVolume buildable = new EditablePersistentVolumeClaimVolume(fluent.getVolumeName(),fluent.getClaimName(),fluent.isReadOnly());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            PersistentVolumeClaimVolumeBuilder that = (PersistentVolumeClaimVolumeBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
