package io.dekorate.kubernetes.config;

import java.lang.String;
import io.dekorate.kubernetes.annotation.Protocol;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class Port{

    private String name;
    private int containerPort;
    private int hostPort = 0;
    private String path = "/";
    private Protocol protocol = io.dekorate.kubernetes.annotation.Protocol.TCP;

    public Port(){
    }
    public Port(String name,int containerPort,int hostPort,String path,Protocol protocol){
            this.name = name;
            this.containerPort = containerPort;
            this.hostPort = hostPort;
            this.path = path != null ? path : "/";
            this.protocol = protocol != null ? protocol : io.dekorate.kubernetes.annotation.Protocol.TCP;
    }

    public String getName(){
            return this.name;
    }

    public int getContainerPort(){
            return this.containerPort;
    }

    public int getHostPort(){
            return this.hostPort;
    }

    public String getPath(){
            return this.path;
    }

    public Protocol getProtocol(){
            return this.protocol;
    }




}
