package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class PortBuilder extends PortFluentImpl<PortBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.Port,PortBuilder>{

    PortFluent<?> fluent;
    Boolean validationEnabled;

    public PortBuilder(){
            this(true);
    }
    public PortBuilder(Boolean validationEnabled){
            this(new Port(), validationEnabled);
    }
    public PortBuilder(PortFluent<?> fluent){
            this(fluent, true);
    }
    public PortBuilder(PortFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Port(), validationEnabled);
    }
    public PortBuilder(PortFluent<?> fluent,io.dekorate.kubernetes.config.Port instance){
            this(fluent, instance, true);
    }
    public PortBuilder(PortFluent<?> fluent,io.dekorate.kubernetes.config.Port instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withName(instance.getName()); 
            fluent.withContainerPort(instance.getContainerPort()); 
            fluent.withHostPort(instance.getHostPort()); 
            fluent.withPath(instance.getPath()); 
            fluent.withProtocol(instance.getProtocol()); 
            this.validationEnabled = validationEnabled; 
    }
    public PortBuilder(io.dekorate.kubernetes.config.Port instance){
            this(instance,true);
    }
    public PortBuilder(io.dekorate.kubernetes.config.Port instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withName(instance.getName()); 
            this.withContainerPort(instance.getContainerPort()); 
            this.withHostPort(instance.getHostPort()); 
            this.withPath(instance.getPath()); 
            this.withProtocol(instance.getProtocol()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditablePort build(){
            EditablePort buildable = new EditablePort(fluent.getName(),fluent.getContainerPort(),fluent.getHostPort(),fluent.getPath(),fluent.getProtocol());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            PortBuilder that = (PortBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
