package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import io.dekorate.kubernetes.annotation.Protocol;
import java.lang.Boolean;

public class PortFluentImpl<A extends PortFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements PortFluent<A>{

    private String name;
    private int containerPort;
    private int hostPort = 0;
    private String path = "/";
    private Protocol protocol = io.dekorate.kubernetes.annotation.Protocol.TCP;

    public PortFluentImpl(){
    }
    public PortFluentImpl(io.dekorate.kubernetes.config.Port instance){
            this.withName(instance.getName()); 
            this.withContainerPort(instance.getContainerPort()); 
            this.withHostPort(instance.getHostPort()); 
            this.withPath(instance.getPath()); 
            this.withProtocol(instance.getProtocol()); 
    }

    public String getName(){
            return this.name;
    }

    public A withName(String name){
            this.name=name; return (A) this;
    }

    public Boolean hasName(){
            return this.name != null;
    }

    public A withNewName(String arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuilder arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuffer arg1){
            return (A)withName(new String(arg1));
    }

    public int getContainerPort(){
            return this.containerPort;
    }

    public A withContainerPort(int containerPort){
            this.containerPort=containerPort; return (A) this;
    }

    public Boolean hasContainerPort(){
            return true;
    }

    public int getHostPort(){
            return this.hostPort;
    }

    public A withHostPort(int hostPort){
            this.hostPort=hostPort; return (A) this;
    }

    public Boolean hasHostPort(){
            return true;
    }

    public String getPath(){
            return this.path;
    }

    public A withPath(String path){
            this.path=path; return (A) this;
    }

    public Boolean hasPath(){
            return this.path != null;
    }

    public A withNewPath(String arg1){
            return (A)withPath(new String(arg1));
    }

    public A withNewPath(StringBuilder arg1){
            return (A)withPath(new String(arg1));
    }

    public A withNewPath(StringBuffer arg1){
            return (A)withPath(new String(arg1));
    }

    public Protocol getProtocol(){
            return this.protocol;
    }

    public A withProtocol(Protocol protocol){
            this.protocol=protocol; return (A) this;
    }

    public Boolean hasProtocol(){
            return this.protocol != null;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            PortFluentImpl that = (PortFluentImpl) o;
            if (name != null ? !name.equals(that.name) :that.name != null) return false;
            if (containerPort != that.containerPort) return false;
            if (hostPort != that.hostPort) return false;
            if (path != null ? !path.equals(that.path) :that.path != null) return false;
            if (protocol != null ? !protocol.equals(that.protocol) :that.protocol != null) return false;
            return true;
    }




}
