package io.dekorate.kubernetes.config;

import java.lang.String;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class Probe{

    private String httpActionPath = "";
    private String execAction = "";
    private String tcpSocketAction = "";
    private int initialDelaySeconds = 0;
    private int periodSeconds = 30;
    private int timeoutSeconds = 10;
    private int successThreshold = 1;
    private int failureThreshold = 3;

    public Probe(){
    }
    public Probe(String httpActionPath,String execAction,String tcpSocketAction,int initialDelaySeconds,int periodSeconds,int timeoutSeconds,int successThreshold,int failureThreshold){
            this.httpActionPath = httpActionPath != null ? httpActionPath : "";
            this.execAction = execAction != null ? execAction : "";
            this.tcpSocketAction = tcpSocketAction != null ? tcpSocketAction : "";
            this.initialDelaySeconds = initialDelaySeconds;
            this.periodSeconds = periodSeconds;
            this.timeoutSeconds = timeoutSeconds;
            this.successThreshold = successThreshold;
            this.failureThreshold = failureThreshold;
    }

    public String getHttpActionPath(){
            return this.httpActionPath;
    }

    public String getExecAction(){
            return this.execAction;
    }

    public String getTcpSocketAction(){
            return this.tcpSocketAction;
    }

    public int getInitialDelaySeconds(){
            return this.initialDelaySeconds;
    }

    public int getPeriodSeconds(){
            return this.periodSeconds;
    }

    public int getTimeoutSeconds(){
            return this.timeoutSeconds;
    }

    public int getSuccessThreshold(){
            return this.successThreshold;
    }

    public int getFailureThreshold(){
            return this.failureThreshold;
    }




}
