package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class ProbeFluentImpl<A extends ProbeFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements ProbeFluent<A>{

    private String httpActionPath = "";
    private String execAction = "";
    private String tcpSocketAction = "";
    private int initialDelaySeconds = 0;
    private int periodSeconds = 30;
    private int timeoutSeconds = 10;
    private int successThreshold = 1;
    private int failureThreshold = 3;

    public ProbeFluentImpl(){
    }
    public ProbeFluentImpl(io.dekorate.kubernetes.config.Probe instance){
            this.withHttpActionPath(instance.getHttpActionPath()); 
            this.withExecAction(instance.getExecAction()); 
            this.withTcpSocketAction(instance.getTcpSocketAction()); 
            this.withInitialDelaySeconds(instance.getInitialDelaySeconds()); 
            this.withPeriodSeconds(instance.getPeriodSeconds()); 
            this.withTimeoutSeconds(instance.getTimeoutSeconds()); 
            this.withSuccessThreshold(instance.getSuccessThreshold()); 
            this.withFailureThreshold(instance.getFailureThreshold()); 
    }

    public String getHttpActionPath(){
            return this.httpActionPath;
    }

    public A withHttpActionPath(String httpActionPath){
            this.httpActionPath=httpActionPath; return (A) this;
    }

    public Boolean hasHttpActionPath(){
            return this.httpActionPath != null;
    }

    public A withNewHttpActionPath(String arg1){
            return (A)withHttpActionPath(new String(arg1));
    }

    public A withNewHttpActionPath(StringBuilder arg1){
            return (A)withHttpActionPath(new String(arg1));
    }

    public A withNewHttpActionPath(StringBuffer arg1){
            return (A)withHttpActionPath(new String(arg1));
    }

    public String getExecAction(){
            return this.execAction;
    }

    public A withExecAction(String execAction){
            this.execAction=execAction; return (A) this;
    }

    public Boolean hasExecAction(){
            return this.execAction != null;
    }

    public A withNewExecAction(String arg1){
            return (A)withExecAction(new String(arg1));
    }

    public A withNewExecAction(StringBuilder arg1){
            return (A)withExecAction(new String(arg1));
    }

    public A withNewExecAction(StringBuffer arg1){
            return (A)withExecAction(new String(arg1));
    }

    public String getTcpSocketAction(){
            return this.tcpSocketAction;
    }

    public A withTcpSocketAction(String tcpSocketAction){
            this.tcpSocketAction=tcpSocketAction; return (A) this;
    }

    public Boolean hasTcpSocketAction(){
            return this.tcpSocketAction != null;
    }

    public A withNewTcpSocketAction(String arg1){
            return (A)withTcpSocketAction(new String(arg1));
    }

    public A withNewTcpSocketAction(StringBuilder arg1){
            return (A)withTcpSocketAction(new String(arg1));
    }

    public A withNewTcpSocketAction(StringBuffer arg1){
            return (A)withTcpSocketAction(new String(arg1));
    }

    public int getInitialDelaySeconds(){
            return this.initialDelaySeconds;
    }

    public A withInitialDelaySeconds(int initialDelaySeconds){
            this.initialDelaySeconds=initialDelaySeconds; return (A) this;
    }

    public Boolean hasInitialDelaySeconds(){
            return true;
    }

    public int getPeriodSeconds(){
            return this.periodSeconds;
    }

    public A withPeriodSeconds(int periodSeconds){
            this.periodSeconds=periodSeconds; return (A) this;
    }

    public Boolean hasPeriodSeconds(){
            return true;
    }

    public int getTimeoutSeconds(){
            return this.timeoutSeconds;
    }

    public A withTimeoutSeconds(int timeoutSeconds){
            this.timeoutSeconds=timeoutSeconds; return (A) this;
    }

    public Boolean hasTimeoutSeconds(){
            return true;
    }

    public int getSuccessThreshold(){
            return this.successThreshold;
    }

    public A withSuccessThreshold(int successThreshold){
            this.successThreshold=successThreshold; return (A) this;
    }

    public Boolean hasSuccessThreshold(){
            return true;
    }

    public int getFailureThreshold(){
            return this.failureThreshold;
    }

    public A withFailureThreshold(int failureThreshold){
            this.failureThreshold=failureThreshold; return (A) this;
    }

    public Boolean hasFailureThreshold(){
            return true;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            ProbeFluentImpl that = (ProbeFluentImpl) o;
            if (httpActionPath != null ? !httpActionPath.equals(that.httpActionPath) :that.httpActionPath != null) return false;
            if (execAction != null ? !execAction.equals(that.execAction) :that.execAction != null) return false;
            if (tcpSocketAction != null ? !tcpSocketAction.equals(that.tcpSocketAction) :that.tcpSocketAction != null) return false;
            if (initialDelaySeconds != that.initialDelaySeconds) return false;
            if (periodSeconds != that.periodSeconds) return false;
            if (timeoutSeconds != that.timeoutSeconds) return false;
            if (successThreshold != that.successThreshold) return false;
            if (failureThreshold != that.failureThreshold) return false;
            return true;
    }




}
