package io.dekorate.project;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class BuildInfoBuilder extends BuildInfoFluentImpl<BuildInfoBuilder> implements VisitableBuilder<BuildInfo,BuildInfoBuilder>{

    BuildInfoFluent<?> fluent;
    Boolean validationEnabled;

    public BuildInfoBuilder(){
            this(true);
    }
    public BuildInfoBuilder(Boolean validationEnabled){
            this(new BuildInfo(), validationEnabled);
    }
    public BuildInfoBuilder(BuildInfoFluent<?> fluent){
            this(fluent, true);
    }
    public BuildInfoBuilder(BuildInfoFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new BuildInfo(), validationEnabled);
    }
    public BuildInfoBuilder(BuildInfoFluent<?> fluent,BuildInfo instance){
            this(fluent, instance, true);
    }
    public BuildInfoBuilder(BuildInfoFluent<?> fluent,BuildInfo instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withName(instance.getName()); 
            fluent.withVersion(instance.getVersion()); 
            fluent.withPackaging(instance.getPackaging()); 
            fluent.withBuildTool(instance.getBuildTool()); 
            fluent.withOutputFile(instance.getOutputFile()); 
            fluent.withClassOutputDir(instance.getClassOutputDir()); 
            fluent.withResourceDir(instance.getResourceDir()); 
            this.validationEnabled = validationEnabled; 
    }
    public BuildInfoBuilder(BuildInfo instance){
            this(instance,true);
    }
    public BuildInfoBuilder(BuildInfo instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withName(instance.getName()); 
            this.withVersion(instance.getVersion()); 
            this.withPackaging(instance.getPackaging()); 
            this.withBuildTool(instance.getBuildTool()); 
            this.withOutputFile(instance.getOutputFile()); 
            this.withClassOutputDir(instance.getClassOutputDir()); 
            this.withResourceDir(instance.getResourceDir()); 
            this.validationEnabled = validationEnabled; 
    }

    public io.dekorate.project.EditableBuildInfo build(){
            EditableBuildInfo buildable = new EditableBuildInfo(fluent.getName(),fluent.getVersion(),fluent.getPackaging(),fluent.getBuildTool(),fluent.getOutputFile(),fluent.getClassOutputDir());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            BuildInfoBuilder that = (BuildInfoBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
