package io.dekorate.project;

import java.nio.file.Path;
import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class BuildInfoFluentImpl<A extends BuildInfoFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements BuildInfoFluent<A>{

    private String name;
    private String version;
    private String packaging;
    private String buildTool;
    private Path outputFile;
    private Path classOutputDir;
    private Path resourceDir;

    public BuildInfoFluentImpl(){
    }
    public BuildInfoFluentImpl(BuildInfo instance){
            this.withName(instance.getName()); 
            this.withVersion(instance.getVersion()); 
            this.withPackaging(instance.getPackaging()); 
            this.withBuildTool(instance.getBuildTool()); 
            this.withOutputFile(instance.getOutputFile()); 
            this.withClassOutputDir(instance.getClassOutputDir()); 
            this.withResourceDir(instance.getResourceDir()); 
    }

    public String getName(){
            return this.name;
    }

    public A withName(String name){
            this.name=name; return (A) this;
    }

    public Boolean hasName(){
            return this.name != null;
    }

    public A withNewName(String arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuilder arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuffer arg1){
            return (A)withName(new String(arg1));
    }

    public String getVersion(){
            return this.version;
    }

    public A withVersion(String version){
            this.version=version; return (A) this;
    }

    public Boolean hasVersion(){
            return this.version != null;
    }

    public A withNewVersion(String arg1){
            return (A)withVersion(new String(arg1));
    }

    public A withNewVersion(StringBuilder arg1){
            return (A)withVersion(new String(arg1));
    }

    public A withNewVersion(StringBuffer arg1){
            return (A)withVersion(new String(arg1));
    }

    public String getPackaging(){
            return this.packaging;
    }

    public A withPackaging(String packaging){
            this.packaging=packaging; return (A) this;
    }

    public Boolean hasPackaging(){
            return this.packaging != null;
    }

    public A withNewPackaging(String arg1){
            return (A)withPackaging(new String(arg1));
    }

    public A withNewPackaging(StringBuilder arg1){
            return (A)withPackaging(new String(arg1));
    }

    public A withNewPackaging(StringBuffer arg1){
            return (A)withPackaging(new String(arg1));
    }

    public String getBuildTool(){
            return this.buildTool;
    }

    public A withBuildTool(String buildTool){
            this.buildTool=buildTool; return (A) this;
    }

    public Boolean hasBuildTool(){
            return this.buildTool != null;
    }

    public A withNewBuildTool(String arg1){
            return (A)withBuildTool(new String(arg1));
    }

    public A withNewBuildTool(StringBuilder arg1){
            return (A)withBuildTool(new String(arg1));
    }

    public A withNewBuildTool(StringBuffer arg1){
            return (A)withBuildTool(new String(arg1));
    }

    public Path getOutputFile(){
            return this.outputFile;
    }

    public A withOutputFile(Path outputFile){
            this.outputFile=outputFile; return (A) this;
    }

    public Boolean hasOutputFile(){
            return this.outputFile != null;
    }

    public Path getClassOutputDir(){
            return this.classOutputDir;
    }

    public A withClassOutputDir(Path classOutputDir){
            this.classOutputDir=classOutputDir; return (A) this;
    }

    public Boolean hasClassOutputDir(){
            return this.classOutputDir != null;
    }

    public Path getResourceDir(){
            return this.resourceDir;
    }

    public A withResourceDir(Path resourceDir){
            this.resourceDir=resourceDir; return (A) this;
    }

    public Boolean hasResourceDir(){
            return this.resourceDir != null;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            BuildInfoFluentImpl that = (BuildInfoFluentImpl) o;
            if (name != null ? !name.equals(that.name) :that.name != null) return false;
            if (version != null ? !version.equals(that.version) :that.version != null) return false;
            if (packaging != null ? !packaging.equals(that.packaging) :that.packaging != null) return false;
            if (buildTool != null ? !buildTool.equals(that.buildTool) :that.buildTool != null) return false;
            if (outputFile != null ? !outputFile.equals(that.outputFile) :that.outputFile != null) return false;
            if (classOutputDir != null ? !classOutputDir.equals(that.classOutputDir) :that.classOutputDir != null) return false;
            if (resourceDir != null ? !resourceDir.equals(that.resourceDir) :that.resourceDir != null) return false;
            return true;
    }




}
