package io.dekorate.project;

import java.nio.file.Path;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Fluent;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.lang.String;
import java.lang.StringBuffer;
import java.lang.Deprecated;
import java.lang.Boolean;
import io.sundr.builder.annotations.Buildable;

public interface ProjectFluent<A extends ProjectFluent<A>> extends Fluent<A>{


    public Path getRoot();
    public A withRoot(Path root);
    public Boolean hasRoot();
    public String getDekorateInputDir();
    public A withDekorateInputDir(String dekorateInputDir);
    public Boolean hasDekorateInputDir();
    public A withNewDekorateInputDir(String arg1);
    public A withNewDekorateInputDir(StringBuilder arg1);
    public A withNewDekorateInputDir(StringBuffer arg1);
    public String getDekorateOutputDir();
    public A withDekorateOutputDir(String dekorateOutputDir);
    public Boolean hasDekorateOutputDir();
    public A withNewDekorateOutputDir(String arg1);
    public A withNewDekorateOutputDir(StringBuilder arg1);
    public A withNewDekorateOutputDir(StringBuffer arg1);
    
/**
 * This method has been deprecated, please use method buildBuildInfo instead.
 * @return The buildable object.
 */
@Deprecated public BuildInfo getBuildInfo();
    public BuildInfo buildBuildInfo();
    public A withBuildInfo(BuildInfo buildInfo);
    public Boolean hasBuildInfo();
    public ProjectFluent.BuildInfoNested<A> withNewBuildInfo();
    public ProjectFluent.BuildInfoNested<A> withNewBuildInfoLike(BuildInfo item);
    public ProjectFluent.BuildInfoNested<A> editBuildInfo();
    public ProjectFluent.BuildInfoNested<A> editOrNewBuildInfo();
    public ProjectFluent.BuildInfoNested<A> editOrNewBuildInfoLike(BuildInfo item);
    
/**
 * This method has been deprecated, please use method buildScmInfo instead.
 * @return The buildable object.
 */
@Deprecated public ScmInfo getScmInfo();
    public ScmInfo buildScmInfo();
    public A withScmInfo(ScmInfo scmInfo);
    public Boolean hasScmInfo();
    public ProjectFluent.ScmInfoNested<A> withNewScmInfo();
    public ProjectFluent.ScmInfoNested<A> withNewScmInfoLike(ScmInfo item);
    public ProjectFluent.ScmInfoNested<A> editScmInfo();
    public ProjectFluent.ScmInfoNested<A> editOrNewScmInfo();
    public ProjectFluent.ScmInfoNested<A> editOrNewScmInfoLike(ScmInfo item);

    public interface BuildInfoNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,BuildInfoFluent<ProjectFluent.BuildInfoNested<N>>{

        
    public N and();    public N endBuildInfo();
}
    public interface ScmInfoNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ScmInfoFluent<ProjectFluent.ScmInfoNested<N>>{

        
    public N and();    public N endScmInfo();
}


}
