package io.dekorate.project;

import java.nio.file.Path;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.lang.String;
import java.lang.StringBuffer;
import java.lang.Deprecated;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.Boolean;

public class ProjectFluentImpl<A extends ProjectFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements ProjectFluent<A>{

    private Path root;
    private String dekorateInputDir;
    private String dekorateOutputDir;
    private BuildInfoBuilder buildInfo;
    private ScmInfoBuilder scmInfo;

    public ProjectFluentImpl(){
    }
    public ProjectFluentImpl(Project instance){
            this.withRoot(instance.getRoot()); 
            this.withDekorateInputDir(instance.getDekorateInputDir()); 
            this.withDekorateOutputDir(instance.getDekorateOutputDir()); 
            this.withBuildInfo(instance.getBuildInfo()); 
            this.withScmInfo(instance.getScmInfo()); 
    }

    public Path getRoot(){
            return this.root;
    }

    public A withRoot(Path root){
            this.root=root; return (A) this;
    }

    public Boolean hasRoot(){
            return this.root != null;
    }

    public String getDekorateInputDir(){
            return this.dekorateInputDir;
    }

    public A withDekorateInputDir(String dekorateInputDir){
            this.dekorateInputDir=dekorateInputDir; return (A) this;
    }

    public Boolean hasDekorateInputDir(){
            return this.dekorateInputDir != null;
    }

    public A withNewDekorateInputDir(String arg1){
            return (A)withDekorateInputDir(new String(arg1));
    }

    public A withNewDekorateInputDir(StringBuilder arg1){
            return (A)withDekorateInputDir(new String(arg1));
    }

    public A withNewDekorateInputDir(StringBuffer arg1){
            return (A)withDekorateInputDir(new String(arg1));
    }

    public String getDekorateOutputDir(){
            return this.dekorateOutputDir;
    }

    public A withDekorateOutputDir(String dekorateOutputDir){
            this.dekorateOutputDir=dekorateOutputDir; return (A) this;
    }

    public Boolean hasDekorateOutputDir(){
            return this.dekorateOutputDir != null;
    }

    public A withNewDekorateOutputDir(String arg1){
            return (A)withDekorateOutputDir(new String(arg1));
    }

    public A withNewDekorateOutputDir(StringBuilder arg1){
            return (A)withDekorateOutputDir(new String(arg1));
    }

    public A withNewDekorateOutputDir(StringBuffer arg1){
            return (A)withDekorateOutputDir(new String(arg1));
    }

    
/**
 * This method has been deprecated, please use method buildBuildInfo instead.
 * @return The buildable object.
 */
@Deprecated public BuildInfo getBuildInfo(){
            return this.buildInfo!=null?this.buildInfo.build():null;
    }

    public BuildInfo buildBuildInfo(){
            return this.buildInfo!=null?this.buildInfo.build():null;
    }

    public A withBuildInfo(BuildInfo buildInfo){
            _visitables.get("buildInfo").remove(this.buildInfo);
            if (buildInfo!=null){ this.buildInfo= new BuildInfoBuilder(buildInfo); _visitables.get("buildInfo").add(this.buildInfo);} return (A) this;
    }

    public Boolean hasBuildInfo(){
            return this.buildInfo != null;
    }

    public ProjectFluent.BuildInfoNested<A> withNewBuildInfo(){
            return new BuildInfoNestedImpl();
    }

    public ProjectFluent.BuildInfoNested<A> withNewBuildInfoLike(BuildInfo item){
            return new BuildInfoNestedImpl(item);
    }

    public ProjectFluent.BuildInfoNested<A> editBuildInfo(){
            return withNewBuildInfoLike(getBuildInfo());
    }

    public ProjectFluent.BuildInfoNested<A> editOrNewBuildInfo(){
            return withNewBuildInfoLike(getBuildInfo() != null ? getBuildInfo(): new BuildInfoBuilder().build());
    }

    public ProjectFluent.BuildInfoNested<A> editOrNewBuildInfoLike(BuildInfo item){
            return withNewBuildInfoLike(getBuildInfo() != null ? getBuildInfo(): item);
    }

    
/**
 * This method has been deprecated, please use method buildScmInfo instead.
 * @return The buildable object.
 */
@Deprecated public ScmInfo getScmInfo(){
            return this.scmInfo!=null?this.scmInfo.build():null;
    }

    public ScmInfo buildScmInfo(){
            return this.scmInfo!=null?this.scmInfo.build():null;
    }

    public A withScmInfo(ScmInfo scmInfo){
            _visitables.get("scmInfo").remove(this.scmInfo);
            if (scmInfo!=null){ this.scmInfo= new ScmInfoBuilder(scmInfo); _visitables.get("scmInfo").add(this.scmInfo);} return (A) this;
    }

    public Boolean hasScmInfo(){
            return this.scmInfo != null;
    }

    public ProjectFluent.ScmInfoNested<A> withNewScmInfo(){
            return new ScmInfoNestedImpl();
    }

    public ProjectFluent.ScmInfoNested<A> withNewScmInfoLike(ScmInfo item){
            return new ScmInfoNestedImpl(item);
    }

    public ProjectFluent.ScmInfoNested<A> editScmInfo(){
            return withNewScmInfoLike(getScmInfo());
    }

    public ProjectFluent.ScmInfoNested<A> editOrNewScmInfo(){
            return withNewScmInfoLike(getScmInfo() != null ? getScmInfo(): new ScmInfoBuilder().build());
    }

    public ProjectFluent.ScmInfoNested<A> editOrNewScmInfoLike(ScmInfo item){
            return withNewScmInfoLike(getScmInfo() != null ? getScmInfo(): item);
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            ProjectFluentImpl that = (ProjectFluentImpl) o;
            if (root != null ? !root.equals(that.root) :that.root != null) return false;
            if (dekorateInputDir != null ? !dekorateInputDir.equals(that.dekorateInputDir) :that.dekorateInputDir != null) return false;
            if (dekorateOutputDir != null ? !dekorateOutputDir.equals(that.dekorateOutputDir) :that.dekorateOutputDir != null) return false;
            if (buildInfo != null ? !buildInfo.equals(that.buildInfo) :that.buildInfo != null) return false;
            if (scmInfo != null ? !scmInfo.equals(that.scmInfo) :that.scmInfo != null) return false;
            return true;
    }


    public class BuildInfoNestedImpl<N> extends BuildInfoFluentImpl<ProjectFluent.BuildInfoNested<N>> implements ProjectFluent.BuildInfoNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final BuildInfoBuilder builder;
    
            BuildInfoNestedImpl(BuildInfo item){
                    this.builder = new BuildInfoBuilder(this, item);
            }
            BuildInfoNestedImpl(){
                    this.builder = new BuildInfoBuilder(this);
            }
    
    public N and(){
            return (N) ProjectFluentImpl.this.withBuildInfo(builder.build());
    }
    public N endBuildInfo(){
            return and();
    }

}
    public class ScmInfoNestedImpl<N> extends ScmInfoFluentImpl<ProjectFluent.ScmInfoNested<N>> implements ProjectFluent.ScmInfoNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final ScmInfoBuilder builder;
    
            ScmInfoNestedImpl(ScmInfo item){
                    this.builder = new ScmInfoBuilder(this, item);
            }
            ScmInfoNestedImpl(){
                    this.builder = new ScmInfoBuilder(this);
            }
    
    public N and(){
            return (N) ProjectFluentImpl.this.withScmInfo(builder.build());
    }
    public N endScmInfo(){
            return and();
    }

}


}
