package io.dekorate.project;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class ScmInfoBuilder extends ScmInfoFluentImpl<ScmInfoBuilder> implements VisitableBuilder<ScmInfo,ScmInfoBuilder>{

    ScmInfoFluent<?> fluent;
    Boolean validationEnabled;

    public ScmInfoBuilder(){
            this(true);
    }
    public ScmInfoBuilder(Boolean validationEnabled){
            this(new ScmInfo(), validationEnabled);
    }
    public ScmInfoBuilder(ScmInfoFluent<?> fluent){
            this(fluent, true);
    }
    public ScmInfoBuilder(ScmInfoFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new ScmInfo(), validationEnabled);
    }
    public ScmInfoBuilder(ScmInfoFluent<?> fluent,ScmInfo instance){
            this(fluent, instance, true);
    }
    public ScmInfoBuilder(ScmInfoFluent<?> fluent,ScmInfo instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withRoot(instance.getRoot()); 
            fluent.withUrl(instance.getUrl()); 
            fluent.withBranch(instance.getBranch()); 
            fluent.withCommit(instance.getCommit()); 
            this.validationEnabled = validationEnabled; 
    }
    public ScmInfoBuilder(ScmInfo instance){
            this(instance,true);
    }
    public ScmInfoBuilder(ScmInfo instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withRoot(instance.getRoot()); 
            this.withUrl(instance.getUrl()); 
            this.withBranch(instance.getBranch()); 
            this.withCommit(instance.getCommit()); 
            this.validationEnabled = validationEnabled; 
    }

    public io.dekorate.project.EditableScmInfo build(){
            EditableScmInfo buildable = new EditableScmInfo(fluent.getRoot(),fluent.getUrl(),fluent.getBranch(),fluent.getCommit());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            ScmInfoBuilder that = (ScmInfoBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
