package io.dekorate.project;

import java.nio.file.Path;
import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class ScmInfoFluentImpl<A extends ScmInfoFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements ScmInfoFluent<A>{

    private Path root;
    private String url;
    private String branch;
    private String commit;

    public ScmInfoFluentImpl(){
    }
    public ScmInfoFluentImpl(ScmInfo instance){
            this.withRoot(instance.getRoot()); 
            this.withUrl(instance.getUrl()); 
            this.withBranch(instance.getBranch()); 
            this.withCommit(instance.getCommit()); 
    }

    public Path getRoot(){
            return this.root;
    }

    public A withRoot(Path root){
            this.root=root; return (A) this;
    }

    public Boolean hasRoot(){
            return this.root != null;
    }

    public String getUrl(){
            return this.url;
    }

    public A withUrl(String url){
            this.url=url; return (A) this;
    }

    public Boolean hasUrl(){
            return this.url != null;
    }

    public A withNewUrl(String arg1){
            return (A)withUrl(new String(arg1));
    }

    public A withNewUrl(StringBuilder arg1){
            return (A)withUrl(new String(arg1));
    }

    public A withNewUrl(StringBuffer arg1){
            return (A)withUrl(new String(arg1));
    }

    public String getBranch(){
            return this.branch;
    }

    public A withBranch(String branch){
            this.branch=branch; return (A) this;
    }

    public Boolean hasBranch(){
            return this.branch != null;
    }

    public A withNewBranch(String arg1){
            return (A)withBranch(new String(arg1));
    }

    public A withNewBranch(StringBuilder arg1){
            return (A)withBranch(new String(arg1));
    }

    public A withNewBranch(StringBuffer arg1){
            return (A)withBranch(new String(arg1));
    }

    public String getCommit(){
            return this.commit;
    }

    public A withCommit(String commit){
            this.commit=commit; return (A) this;
    }

    public Boolean hasCommit(){
            return this.commit != null;
    }

    public A withNewCommit(String arg1){
            return (A)withCommit(new String(arg1));
    }

    public A withNewCommit(StringBuilder arg1){
            return (A)withCommit(new String(arg1));
    }

    public A withNewCommit(StringBuffer arg1){
            return (A)withCommit(new String(arg1));
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            ScmInfoFluentImpl that = (ScmInfoFluentImpl) o;
            if (root != null ? !root.equals(that.root) :that.root != null) return false;
            if (url != null ? !url.equals(that.url) :that.url != null) return false;
            if (branch != null ? !branch.equals(that.branch) :that.branch != null) return false;
            if (commit != null ? !commit.equals(that.commit) :that.commit != null) return false;
            return true;
    }




}
